﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Jonsan
{
    internal class Method
    {
        public string Path { get; set; }
        public Method(string path)
        {
            Path = path;
        }
        private List<List<double>> reading()
        {
            int n = File.ReadAllLines(Path).Length;
            List<List<double>>graph = new List<List<double>>();
            using (StreamReader reader = new StreamReader(Path))
            {
                for (int i = 0; i < n; i++)
                {
                    graph.Add(new List<double>());
                    string text = reader.ReadLine();
                    string[] mas = text.Split(new char[] { ',' });
                    for (int j = 0; j < mas.Length; j++)
                    {
                        graph[i].Add(double.Parse(mas[j]));
                    }

                }

            }
            return graph;
        }

        public void JonsansMethod()
        {
            List<List<double>> graph = reading();
            List<List<double>> itogGraph = new List<List<double>>();
            List<List<double>> firstColumn = new List<List<double>>();
            List<List<double>> secondColumn = new List<List<double>>();
            double downtime = optoptimality(graph);
            while(true)
            {
                double min = Double.MaxValue;
                int firstIndex = 0;
                int secondIndex = 0;
                for(int i = 0; i < graph.Count; i++)
                {
                    for(int j = 0;j < graph[i].Count; j++)
                    {
                        if (graph[i][j] < min)
                        {
                            min = graph[i][j];
                            firstIndex = i;
                            secondIndex = j;
                        }
                    }
                }
                List<List<double>> list = new List<List<double>>();
                List<List<double>> secondList = new List<List<double>>();
                if (secondIndex == 0)
                {
                    for (int i = 0; i < graph.Count; i++)
                    {
                        if (graph[i][0] == min)
                        {
                            list.Add(new List<double> { graph[i][0], graph[i][1] });
                        }
                            
                    }
                    if(list.Count > 1)
                    {
                        double temp;
                        for(int i = 0; i < list.Count; i++)
                        {
                            for (int j = 0;  j < list.Count;  j++)
                            {
                                if (list[i][1] > list[j][1])
                                {
                                    temp = list[i][1];
                                    list[i][1]= list[j][1];
                                    list[j][1] = temp;
                                }
                            }
                        }
                        for(int i = 0; i < list.Count; i++)
                        {
                            firstColumn.Add(list[i]);
                            for(int j = 0; j < graph.Count; j++)
                            {
                                if (graph[j][0] == list[i][0] && graph[j][1] == list[i][1])
                                {
                                    graph.RemoveAt(j);
                                    break;
                                }
                            }
                            
                        }
                    }
                    else
                    {
                        firstColumn.Add(graph[firstIndex]);
                        graph.RemoveAt(firstIndex);
                    }
                    

                }
                else
                {
                    for (int i = 0; i < graph.Count; i++)
                    {
                        if (graph[i][1] == min)
                        {
                            secondList.Add(new List<double> { graph[i][0], graph[i][1] });
                        }

                    }
                    if (secondList.Count > 1)
                    {
                        double temp;
                        for (int i = 0; i < secondList.Count; i++)
                        {
                            for (int j = 0; j < secondList.Count; j++)
                            {
                                if (secondList[i][0] > secondList[j][0])
                                {
                                    temp = secondList[i][1];
                                    secondList[i][1] = secondList[j][1];
                                    secondList[j][1] = temp;
                                }
                            }
                        }
                        for (int i = 0; i < secondList.Count; i++)
                        {
                            secondColumn.Add(secondList[i]);
                            for (int j = 0; j < graph.Count; j++)
                            {
                                if (graph[j][0] == secondList[i][0] && graph[j][1] == secondList[i][1])
                                {
                                    graph.RemoveAt(j);
                                    break;
                                }
                            }

                        }
                    }
                    else
                    {
                        secondColumn.Add(graph[firstIndex]);
                        graph.RemoveAt(firstIndex);
                    }
                }
                if(graph.Count == 0)
                {
                    itogGraph.AddRange(firstColumn);
                    secondColumn.Reverse();
                    itogGraph.AddRange(secondColumn);
                    break;

                }
            }
            double downtimeOpt = optoptimality(itogGraph);
            writing(itogGraph, downtime, downtimeOpt);
        }

        private double optoptimality(List<List<double>> graph)
        {
            double maxDowntime = graph[0][0];
            double downtime;
            int index = 1;
            while(index < graph.Count)
            {
                double firstSum = 0;
                for(int i = 0; i <= index; i++)
                {
                    firstSum += graph[i][0];
                }
                double secondSum = 0;
                for (int i = 0; i < index; i++)
                {
                    secondSum += graph[i][1];
                }
                downtime = firstSum - secondSum;
                if(maxDowntime < downtime)
                {
                    maxDowntime = downtime;
                }
                index++;
            }

            return maxDowntime;

        }
        private void writing(List<List<double>> graph, double num1, double num2)
        {
            FileStream file1 = new FileStream("itog.txt", FileMode.OpenOrCreate);
            StreamWriter writer = new StreamWriter(file1);
            writer.WriteLine("Простой второго станка до оптимизации: " + num1);
            writer.WriteLine("Простой второго станка после оптимизации: " + num2);
            writer.WriteLine("Распределение работы между двумя станками: ");
            for (int i = 0; i < graph.Count; i++)
            {
                for(int j = 0; j < graph[i].Count; j++)
                {
                    writer.Write(graph[i][j] + " ");
                }
                writer.Write("\n");
            }
            writer.Close();
        }



    }
}
